<?php

namespace FiloBlu\Storelocator\Model\Plugin\Checkout;

use Magento\Quote\Model\QuoteRepository;
use Magento\Framework\Exception\InputException;
use Magento\Checkout\Model\ShippingInformationManagement as ShippingManagement;
use Magento\Checkout\Api\Data\ShippingInformationInterface;

class ShippingInformationManagement {

    protected $_helper;

    public function __construct(\FiloBlu\Storelocator\Helper\Data $helper, QuoteRepository $quoteRepository
    ) {
        $this->_helper = $helper;
        $this->_quoteRepository = $quoteRepository;
    }

    /**
     * @param ShippingManagement $subject
     * @param $cartId
     * @param ShippingInformationInterface $addressInformation
     */
    public function beforeSaveAddressInformation(
    ShippingManagement $subject, $cartId, ShippingInformationInterface $addressInformation
    ) {

      if ($this->_helper->getConfig("carriers/pickup_in_store/active")) {

          $quote = $this->_quoteRepository->getActive($cartId);

          $shippingAddress = $addressInformation->getShippingAddress();
          $extAttributes = $shippingAddress->getExtensionAttributes();
          $methodCode = $addressInformation->getShippingMethodCode();

          if ($methodCode == "pickup_in_store") {
            if (!$extAttributes || (int)$extAttributes->getSelectedStoreId() == 0) {
              throw new InputException(__('Select a store for pick up'));
            }
            else {
              $quote->setPickupInStoreId((int)$extAttributes->getSelectedStoreId());
              $quote->setPickupInStoreEmail($extAttributes->getSelectedStoreEmail());
            }
          }
          else {
              $quote->setPickupInStoreId(null);
              $quote->setPickupInStoreEmail(null);
            }
        }
    }
}
